Error using Voxl-tflite-server on Firmware 3.1.0



  • Hey there,
    I am trying to get the voxl-tflite-server to run on my Voxl. I know it is recommended to use 3.3.0 or greater but I experienced some issues with the newer versions and wanted to make it work on this version. Installing it seems to be going alright, but when trying to configure it this error occurs:

    voxl-tflite-server: error while loading shared libraries: libmodal_pipe.so: cannot open shared object file: No such file or directory
    

    I ignored it and went on with the configuration. At the end no configuration file was created in the directory as shown here: https://docs.modalai.com/voxl-tflite-server/
    Furthermore after looking at the service which would be started this is the output of systemctl:

    ~ # systemctl status voxl-tflite-server -l
    ā— voxl-tflite-server.service - voxl-tflite-server
       Loaded: loaded (/usr/bin/voxl-tflite-server; enabled; vendor preset: enabled)
       Active: failed (Result: start-limit) since Thu 1970-01-01 00:00:08 UTC; 52 years 0 months ago
      Process: 2496 ExecStart=/bin/bash -c /usr/bin/voxl-tflite-server (code=exited, status=127)
     Main PID: 2496 (code=exited, status=127)
    
    Jan 01 00:00:08 apq8096 systemd[1]: voxl-tflite-server.service: Service hold-off time over, scheduling restart.
    Jan 01 00:00:08 apq8096 systemd[1]: Stopped voxl-tflite-server.
    Jan 01 00:00:08 apq8096 systemd[1]: voxl-tflite-server.service: Start request repeated too quickly.
    Jan 01 00:00:08 apq8096 systemd[1]: Failed to start voxl-tflite-server.
    Jan 01 00:00:08 apq8096 systemd[1]: voxl-tflite-server.service: Unit entered failed state.
    Jan 01 00:00:08 apq8096 systemd[1]: voxl-tflite-server.service: Failed with result 'start-limit'.
    Jan 01 00:00:11 apq8096 bash[2260]: /usr/bin/voxl-tflite-server: error while loading shared libraries: libmodal_pipe.so: cannot open shared object file: No such file or directory
    Jan 01 00:00:11 apq8096 bash[2310]: /usr/bin/voxl-tflite-server: error while loading shared libraries: libmodal_pipe.so: cannot open shared object file: No such file or directory
    Jan 01 00:00:11 apq8096 bash[2401]: /usr/bin/voxl-tflite-server: error while loading shared libraries: libmodal_pipe.so: cannot open shared object file: No such file or directory
    Jan 01 00:00:11 apq8096 bash[2496]: /usr/bin/voxl-tflite-server: error while loading shared libraries: libmodal_pipe.so: cannot open shared object file: No such file or directory
    
    

    Here is the same error present not being able to load the libraries necessary.
    Help would be appreciated šŸ™‚


  • Dev Team

    @Arrowtec,

    This error is likely from some of our recent package renames, I will try to reproduce on my end. Are you using the dev or stable opkg repo to pull in packages?

    voxl-tflite-server requires libmodal-pipe to run, and is looking for that shared library on initialization. You are missing that file, so try running (on voxl):

    opkg update
    
    // IF ON OPKG DEV
    opkg install --force-reinstall libmodal-pipe
    // IF ON OPKG STABLE 
    opkg install --force-reinstall libmodal_pipe
    

    To verify the install worked correctly, you can grep the /usr/lib64/ folder on voxl and look for this library, i.e.:

    ls /usr/lib64/ | grep modal_pipe
    

    This may occur again with the libmodal-json library (or libmodal_json on stable), but you can follow the same steps above to validate a proper install!



  • I tried to follow your advice but i get the following Error:

    opkg install --force-reinstall libmodal_pipe
    Not selecting libmodal_pipe 2.1.1 as installing it would break existing dependencies.
    Not selecting libmodal_pipe 2.1.1 as installing it would break existing dependencies.
    Not selecting libmodal_pipe 1.2.2 as installing it would break existing dependencies.
    Package libmodal_pipe (1.2.2) installed in root is up to date.
    

    and

    ls /usr/lib64/ | grep modal_pipe
    

    returns Nothing. Do you have any Suggestions?
    Update:
    So apparrently

    opkg list | grep modal_pipe
    libmodal_pipe - 2.1.1 - Interface for services to communicate over posix named pipes
    libmodal_pipe - 1.2.2 - Interface for services to communicate over posix named pipes
    

    they are located in a different lib:

    /usr/lib/libmodal_pipe.so
    

    should the pipe be there?


  • Dev Team

    @Philemon-Benner said in Error using Voxl-tflite-server on Firmware 3.1.0:

    they are located in a different lib:

    It looks like when you installed libmodal_pipe, it only installed the 32-bit version of the libs in /usr/lib/ but the 64-bit versions are missing under /usr/lib64/. voxl-tflite-server is a 64-bit application, so we need the 64-bit versions of all dependencies.

    As opkg complained that upgrading libmodal_pipe will "break existing dependencies", we can try adding the --force-depends option to your opkg install line:

    opkg install --force-reinstall --force-depends libmodal_pipe
    

    Verify the install worked correctly by ensuring you have v2.1.1 installed and the cmd

    ls /usr/lib64/ | grep modal_pipe
    

    returns libmodal_pipe.so.

    See all relevant opkg flags here if interested.



  • Thank you for your Answer we upgraded the Firmware to the newest Version and now it's working properly.


Log in to reply